@echo off
set fdosroot=%cdrom%freedos\setup
set path=%fdosroot%\bin;%fdosroot%\bin\key;%fdosroot%\install;A:\freedos
if "%disksrc%"=="B:" set path=A:;A:\;A:\freedos;%fdosroot%\bin;%fdosroot%\bin\key;%fdosroot%\install
cls
for %%x in ( [%lang%] [%color%] [%key%] [%instmode%] ) do if %%x==[] goto defaults
goto optmenu1

:optmenu1
call %fdosroot%\batch\menu1.bat
echo.
if "%menu1_nr%"=="INSTFDOS" goto optmenu2
if "%menu1_nr%"=="BOOTDISK" call %fdosroot%\batch\bootdisk.bat
if "%menu1_nr%"=="QUIT" LOCALIZE 0.17
if "%menu1_nr%"=="QUIT" goto end
if "%menu1_nr%"=="VIEW" %fdosroot%\bin\pg %cdrom%freedos\docs\install3.txt
if "%menu1_nr%"=="REBOOT" FDISK /REBOOT
cls
goto optmenu1

:defaults
alias menu=%fdosroot%\batch\autorun.bat
set nlspath=%fdosroot%\nls
set lang=EN
set color=Color
for %%x in ( 8086 80186 80286 ) do if "%cputype%"=="%%x" set color=Mono
set key=
set instmode=Mini
if not "%disksrc%"=="B:" goto optmenu1
if exist A:\freedos\localize.%lang% goto optmenu1
if exist %fdosroot%\nls\localize.%lang% copy /y %fdosroot%\nls\localize.%lang% A:\freedos\localize.%lang%
if exist A:\freedos\localize.%lang% set nlspath=A:\freedos
cls
goto optmenu1

:optmenu2
cdd %fdosroot%
call %fdosroot%\batch\menu2.bat
echo.
if "%menu2_nr%"=="INSTFDOS" goto installr
if "%menu2_nr%"=="SETLANG"  goto sel_lang
if "%menu2_nr%"=="SETSCRN"  goto sel_scrn
if "%menu2_nr%"=="SETKEYB"  goto sel_keyb
if "%menu2_nr%"=="SETSIZE"  goto sel_mode
if "%menu2_nr%"=="QUIT"     goto optmenu1
goto optmenu2

:installr
rem ## provide general information
cls
for %%x in ( %fdosroot%\LANGUAGE\%LANG%\BETA*.TXT ) DO if exist %%x TYPE %%x 
echo.
pause 
rem ## provide installation notes.
for %%x in ( %fdosroot%\LANGUAGE\%LANG%\INST.TXT ) DO if exist %%x %cdrom%\freedos\setup\bin\pg %%x 

set TEXTMENU=
call %fdosroot%\batch\textmenu.bat
if "%TEXTMENU%"=="QUIT" goto optmenu2
if "%TEXTMENU%"=="QUIT" goto optmenu2
rem Do not CALL this, but let it be the end-option.
rem But what about the INSTALLER not being run? how to solve that?
if exist %fdosroot%\batch\postinst.bat %fdosroot%\batch\postinst.bat
goto optmenu2

:sel_lang
cls
localize 0.0
echo.
echo Please select language to use during Install, this only
echo effects programs that check the LANG environment variable,
echo and only during the installation process (ie until you reboot).
echo.
echo NOTE:  The language selected will be used when translated
echo       text exists, otherwise English will be used.  The
echo       English is the original, the translations may have
echo       errors or be out of date.
echo.
echo         Choose desired Installation Language (SET LANG=?)
echo ==============================================================================
echo 1) EN  English - The default, and used when translations are not available
echo 2) ES  Espagnol
echo 3) NL  Nederlands
echo 4) DE  Deutsch
echo.
%fdosroot%\bin\choice /C:1234 "           "
IF ERRORLEVEL 1 set LANG=EN
IF ERRORLEVEL 2 set LANG=ES
IF ERRORLEVEL 3 set LANG=NL
IF ERRORLEVEL 4 set LANG=DE
if not "%disksrc%"=="B:" goto optmenu2
if exist A:\freedos\localize.%lang% goto optmenu2
if exist %fdosroot%\nls\localize.%lang% copy /y %fdosroot%\nls\localize.%lang% A:\freedos\localize.%lang%
if exist A:\freedos\localize.%lang% set nlspath=A:\freedos
cls
goto optmenu2

:sel_scrn
echo What kind of monitor do you have?
echo 1) Color     
echo 2) Monochrome
echo.
echo  NB: if graphical installer does not work properly, please pick monochrome
%fdosroot%\bin\choice /C:12 "                "
if errorlevel 1 set color=Color
if errorlevel 2 set color=Mono
goto optmenu2

:sel_keyb
cdd %fdosroot%\bin\key
set input=
cls
CLS
localize 0.0
dir /w /b /-p *.kc
echo.
echo Enter valid keyboard layout (without .KC extension),
set /P input=or hit ENTER to deselect :
if "%input%"=="" goto keyb_err
if exist %input% echo PLEASE enter filename WITHOUT the .kc part!
if not exist %input%.kc goto keyb_err
rem %input%.key exists!
set key=%input%
keyb /u
keyb %key%
set input=
goto optmenu2
:keyb_err
echo You have entered an invalid keyboard layout
echo 1) Keep Current keyboard layout
echo 2) Retry
echo 3) Unset keyboard layout
choice /N /C:123 Please enter your choice:
set input=
if "%errorlevel%"=="1" goto optmenu2
if "%errorlevel%"=="2" goto sel_keyb
set key=
keyb /u
goto optmenu2

:sel_mode
echo What kind of install do you want?
echo 1) Full install
echo 2) Minimal install
%fdosroot%\bin\choice /C:12 "         "
if errorlevel 1 set instmode=Full
if errorlevel 2 set instmode=Mini
goto optmenu2

:end